struts-user mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From Paul Zepernick <Paul.Zepern...@healthsmart.com>
Subject RE: Struts 2.5.x support above Java 8
Date Mon, 12 Nov 2018 12:49:45 GMT
I have taken another run at this with Java 11 ASM 7.0.  I verified that I am really running
asm 7.0 via the mvn dependency:tree.  I am now getting the following stack trace

ERROR DefaultClassFinder Unable to read class [com.hs.iws.actions.prizm.PrizmTemplatesAction$1]
 java.lang.UnsupportedOperationException: This feature requires ASM7
        at org.objectweb.asm.ClassVisitor.visitNestHost(ClassVisitor.java:150)
        at org.objectweb.asm.ClassReader.accept(ClassReader.java:541)
        at org.objectweb.asm.ClassReader.accept(ClassReader.java:391)
        at org.apache.struts2.convention.DefaultClassFinder.readClassDef(DefaultClassFinder.java:462)

I have traced the problem to the source in org.apache.struts2.convention.DefaultClassFinder

public class InfoBuildingVisitor extends ClassVisitor {
        private Info info;
        private ClassFinder classFinder;

        public InfoBuildingVisitor(ClassFinder classFinder) {
            super(Opcodes.ASM5);  // This is the issue raising the Exception
            this.classFinder = classFinder;
        }

I have commented the line above causing the issue.  I assume this would throw an exception
in ASM using anything above 5.


-----Original Message-----
From: Lukasz Lenart <lukaszlenart@apache.org>
Sent: Sunday, November 11, 2018 3:07 AM
To: Struts Users Mailing List <user@struts.apache.org>
Subject: Re: Struts 2.5.x support above Java 8

NOTICE: This email originated from outside of the organization. Do not click links or open
attachments unless you recognize the sender and know the content is safe.

sob., 10 lis 2018 o 01:39 Paul Zepernick <Paul.Zepernick@healthsmart.com> napisał(a):
>
> Has anyone got Struts 2.5 to work for Java 11 or anything above Java 8?  I have a project
that I was trying to migrate to Java 11 using 2.5.18.  I have it compiling, but then ran into
an issue with the ASM library.  I am using the REST plugin, which is dependent on the convention
plugin.  The convention plugin has the dependency to ASM, and I am getting the error mentioned
in this ticket:
> https://na01.safelinks.protection.outlook.com/?url=https%3A%2F%2Fissue
> s.apache.org%2Fjira%2Fprojects%2FWW%2Fissues%2FWW-4866%3Ffilter%3Dallo
> penissues&amp;data=02%7C01%7CPaul.Zepernick%40healthsmart.com%7Cc789d7
> 84442b4141887d08d647acb9f6%7C2ce547c5e80a40628a56f25adceefb52%7C0%7C0%
> 7C636775204519343782&amp;sdata=JFRCeA9TTXRYdn8Yv6MY0ZKccg%2BgkVpuia%2F
> zY381lD0%3D&amp;reserved=0
>
> I have tried Java 10 with ASM 6.0 mentioned in the comments and ASM 7.0 with Java 11.
 Both produced the same IllegalArgumentException already mentioned.  A quick glance at the
source seemed to indicate that ASM changed the constructor on the class that is being called
to accept byte[] instead of InputStream.

Could you post more details? As far I see the constructor that accepts InputStream is still
available.

> My main goal in all of this was to try and ensure we would be running on a supported
JDK as support for 8 is about to be up.  From what I understand, no one from the Java community
has committed to back porting security patches for 8.  Would anyone be willing to share what
they are doing with Java 8 in the enterprise environment if we have to stay on it for Struts
applications?  Are you purchasing, or already have oracle support?

We do plan support JDK 9 and JDK 11 as from Struts 2.6 (in development), maybe we will be
able to port those changes into 2.5.x branch but we will see.


Regards
--
Łukasz
+ 48 606 323 122
+ https://na01.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.le
+ nart.org.pl%2F&amp;data=02%7C01%7CPaul.Zepernick%40healthsmart.com%7Cc
+ 789d784442b4141887d08d647acb9f6%7C2ce547c5e80a40628a56f25adceefb52%7C0
+ %7C0%7C636775204519343782&amp;sdata=YxFK4LlfpQ6zwAPYDGWRC2jAOGeGPquGdg
+ J4VkUm4q4%3D&amp;reserved=0

---------------------------------------------------------------------
To unsubscribe, e-mail: user-unsubscribe@struts.apache.org
For additional commands, e-mail: user-help@struts.apache.org




Disclaimer: This communication and any files transmitted with it may contain information that
is privileged, confidential and/or exempt from disclosure under applicable law. If you are
not the intended recipient, you are hereby notified that any disclosure, copying, distribution,
or use of the information contained herein (including any reliance thereon) is strictly prohibited.
If you received this communication in error, please immediately contact the sender and destroy
the material in its entirety, whether in electronic or hard copy format. Thank you.
Mime
View raw message